Index: /trunk/source/Lib/TAppCommon/program_options_lite.h
===================================================================
--- /trunk/source/Lib/TAppCommon/program_options_lite.h	(revision 1355)
+++ /trunk/source/Lib/TAppCommon/program_options_lite.h	(revision 1356)
@@ -78,9 +78,16 @@
     struct ErrorReporter
     {
+#if NH_MV_SEI
+      ErrorReporter() : is_errored(0), output_on_unknow_parameter(true)  {}
+#else
       ErrorReporter() : is_errored(0) {}
+#endif
       virtual ~ErrorReporter() {}
       virtual std::ostream& error(const std::string& where);
       virtual std::ostream& warn(const std::string& where);
       bool is_errored;
+#if NH_MV_SEI
+      bool output_on_unknow_parameter;
+#endif
     };
 
@@ -98,6 +105,11 @@
     {
 #if NH_MV      
+#if NH_MV_SEI      
+      OptionBase(const std::string& name, const std::string& desc, bool duplicate = false, std::vector< int > maxdim = std::vector< int >(0) )
+        : opt_string(name), opt_desc(desc), opt_duplicate(duplicate), max_dim( maxdim )
+#else
       OptionBase(const std::string& name, const std::string& desc, bool duplicate = false)
         : opt_string(name), opt_desc(desc), opt_duplicate(duplicate)
+#endif
 #else
       OptionBase(const std::string& name, const std::string& desc)
@@ -109,5 +121,97 @@
 
       /* parse argument arg, to obtain a value for the option */
+#if NH_MV_SEI
+      virtual void parse(const std::string& arg, const std::vector<int>& idcs,  ErrorReporter&) = 0;
+      
+      bool   checkDim( std::vector< int > dims, ErrorReporter& err )
+      {     
+        bool doParsing = true; 
+        if ( dims.size() != max_dim.size() )
+        {
+            err.error(" ") << "Number of indices of `" <<  opt_string << "' not matching. Should be " << max_dim.size() << std::endl; 
+            doParsing = false; 
+        }
+
+        for (size_t i = 0 ; i < dims.size(); i++ )
+        {
+          if ( dims[i] >= max_dim[i] )
+          {
+            if (err.output_on_unknow_parameter )
+            {       
+              err.warn(" ") << "Index " << i  << " of  " <<  opt_string << " should be less than " << max_dim[i] << std::endl;             
+              doParsing = false; 
+            }
+          }
+        }
+        return doParsing; 
+      }
+
+      void   xParseVec( const std::string& arg, BoolAry1d& storage )
+      {        
+        char* pcNextStart = (char*) arg.data();
+        char* pcEnd = pcNextStart + arg.length();
+
+        char* pcOldStart = 0; 
+
+        size_t iIdx = 0; 
+
+        while (pcNextStart < pcEnd)
+        {
+          if ( iIdx < storage.size() )
+          {
+            storage[iIdx] = (strtol(pcNextStart, &pcNextStart,10) != 0);
+          }
+          else
+          {
+            storage.push_back(strtol(pcNextStart, &pcNextStart,10) != 0) ;
+          }
+          iIdx++; 
+
+          if ( errno == ERANGE || (pcNextStart == pcOldStart) )
+          {
+            std::cerr << "Error Parsing Bools: `" << arg << "'" << std::endl;
+            exit(EXIT_FAILURE);
+          };   
+          while( (pcNextStart < pcEnd) && ( *pcNextStart == ' ' || *pcNextStart == '\t' || *pcNextStart == '\r' ) ) pcNextStart++;  
+          pcOldStart = pcNextStart;
+        }
+      }
+
+      void   xParseVec( const std::string& arg, IntAry1d& storage )
+      {        
+        storage.clear();
+
+        char* pcNextStart = (char*) arg.data();
+        char* pcEnd = pcNextStart + arg.length();
+
+        char* pcOldStart = 0; 
+
+        size_t iIdx = 0; 
+
+
+        while (pcNextStart < pcEnd)
+        {
+
+          if ( iIdx < storage.size() )
+          {
+            storage[iIdx] = (int) strtol(pcNextStart, &pcNextStart,10);
+          }
+          else
+          {
+            storage.push_back( (int) strtol(pcNextStart, &pcNextStart,10)) ;
+          }
+          iIdx++; 
+          if ( errno == ERANGE || (pcNextStart == pcOldStart) )
+          {
+            std::cerr << "Error Parsing Integers: `" << arg << "'" << std::endl;
+            exit(EXIT_FAILURE);
+          };   
+          while( (pcNextStart < pcEnd) && ( *pcNextStart == ' ' || *pcNextStart == '\t' || *pcNextStart == '\r' ) ) pcNextStart++;  
+          pcOldStart = pcNextStart;
+        }      
+      }
+#else
       virtual void parse(const std::string& arg, ErrorReporter&) = 0;
+#endif
       /* set the argument to the default value */
       virtual void setDefault() = 0;
@@ -117,4 +221,7 @@
 #if NH_MV
       bool        opt_duplicate; 
+#if NH_MV_SEI
+      std::vector<int> max_dim;
+#endif
 #endif
     };
@@ -125,6 +232,11 @@
     {
 #if NH_MV
+#if NH_MV_SEI
+      Option(const std::string& name, T& storage, T default_val, const std::string& desc, bool duplicate = false, std::vector< int > maxdim = std::vector< int >(0) )
+        : OptionBase(name, desc, duplicate, maxdim), opt_storage(storage), opt_default_val(default_val)
+#else
       Option(const std::string& name, T& storage, T default_val, const std::string& desc, bool duplicate = false)
         : OptionBase(name, desc, duplicate), opt_storage(storage), opt_default_val(default_val)
+#endif
 #else
       Option(const std::string& name, T& storage, T default_val, const std::string& desc)
@@ -133,5 +245,9 @@
       {}
 
+#if NH_MV_SEI
+      void parse(const std::string& arg, const std::vector<int>& idcs, ErrorReporter&);
+#else
       void parse(const std::string& arg, ErrorReporter&);
+#endif
 
       void setDefault()
@@ -147,6 +263,14 @@
     template<typename T>
     inline void
+#if NH_MV_SEI
+    Option<T>::parse(const std::string& arg, const std::vector<int>& idcs, ErrorReporter&)
+#else
     Option<T>::parse(const std::string& arg, ErrorReporter&)
-    {
+#endif
+    {
+#if NH_MV_SEI
+      assert( idcs.size() == 0 ); 
+#endif
+      
       std::istringstream arg_ss (arg,std::istringstream::in);
       arg_ss.exceptions(std::ios::failbit);
@@ -165,6 +289,13 @@
     template<>
     inline void
+#if NH_MV_SEI
+    Option<std::string>::parse(const std::string& arg, const std::vector<int>& idcs, ErrorReporter&)
+#else
     Option<std::string>::parse(const std::string& arg, ErrorReporter&)
-    {
+#endif
+    {
+#if NH_MV_SEI
+      assert( idcs.size() == 0 ); 
+#endif
       opt_storage = arg;
     }
@@ -173,8 +304,17 @@
     template<>
     inline void
+#if NH_MV_SEI
+      Option<char*>::parse(const std::string& arg, const std::vector<int>& idcs, ErrorReporter&)
+#else
       Option<char*>::parse(const std::string& arg, ErrorReporter&)
-    {
+#endif
+    {
+#if NH_MV_SEI
+      assert( idcs.size() == 0 ); 
+#endif
       opt_storage = arg.empty() ? NULL : strdup(arg.c_str()) ;
     }
+
+#if !NH_MV_SEI
 
     template<>
@@ -198,10 +338,17 @@
       }      
     }
-
+#endif
 
     template<>    
     inline void
+#if NH_MV_SEI
+      Option< std::vector<double> >::parse(const std::string& arg, const std::vector< int > & idcs, ErrorReporter&)
+#else
       Option< std::vector<double> >::parse(const std::string& arg, ErrorReporter&)
-    {
+#endif
+    {
+#if NH_MV_SEI
+      assert( idcs.size() == 0 ); 
+#endif
       char* pcNextStart = (char*) arg.data();
       char* pcEnd = pcNextStart + arg.length();
@@ -236,4 +383,67 @@
     }
 
+
+#if NH_MV_SEI
+    template<>
+    inline void
+      Option< IntAry1d >::parse(const std::string& arg, const IntAry1d& idcs, ErrorReporter& err)
+    {
+      xParseVec( arg, opt_storage );
+    };
+
+    template<>
+    inline void
+      Option< IntAry2d >::parse(const std::string& arg, const IntAry1d& idcs, ErrorReporter&)
+    {
+      xParseVec( arg, opt_storage[ idcs[0] ] );
+    };
+
+    template<>
+    inline void
+      Option< IntAry3d >::parse(const std::string& arg, const IntAry1d& idcs, ErrorReporter&)
+    {
+      xParseVec ( arg, opt_storage[ idcs[0] ][ idcs[1] ] );
+    };
+#if SEI_DRI_F0169
+    template<>
+    inline void
+    Option< std::vector< std::vector<double> > >::parse(const std::string& arg, const IntAry1d& idcs, ErrorReporter&)
+    {
+        // xParseVec ( arg, opt_storage[ idcs[0] ] );
+        char* pcNextStart = (char*) arg.data();
+        char* pcEnd = pcNextStart + arg.length();
+
+        char* pcOldStart = 0; 
+
+        size_t iIdx = 0; 
+
+        while (pcNextStart < pcEnd)
+        {
+            errno = 0; 
+
+            if ( iIdx < opt_storage[idcs[0]].size() )
+            {
+                opt_storage[idcs[0]][iIdx] = strtod(pcNextStart, &pcNextStart);
+            }
+            else
+            {
+                opt_storage[idcs[0]].push_back( strtod(pcNextStart, &pcNextStart)) ;
+            }
+            iIdx++; 
+
+            if ( errno == ERANGE || (pcNextStart == pcOldStart) )
+            {
+                std::cerr << "Error Parsing Doubles: `" << arg << "'" << std::endl;
+                exit(EXIT_FAILURE);    
+            };   
+            while( (pcNextStart < pcEnd) && ( *pcNextStart == ' ' || *pcNextStart == '\t' || *pcNextStart == '\r' ) ) pcNextStart++;  
+            pcOldStart = pcNextStart; 
+
+        }       
+
+
+    }
+#endif
+#else
     template<>
     inline void
@@ -272,6 +482,54 @@
       }
     }
-
-
+#endif
+
+#if NH_MV_SEI
+
+    template<>
+    inline void
+      Option< StringAry1d  >::parse(const std::string& arg, const std::vector<int>& idcs, ErrorReporter& err )
+    {
+
+      opt_storage[ idcs[ 0 ] ] = arg;
+    };
+
+    template<>
+    inline void
+      Option< StringAry2d  >::parse(const std::string& arg, const std::vector<int>& idcs, ErrorReporter& err )
+    {
+
+      opt_storage[idcs[0]][idcs[1]] = arg;
+    };
+
+
+    template<>
+    inline void
+      Option< std::vector< char*>  >::parse(const std::string& arg, const std::vector<int>& idcs, ErrorReporter& err )
+    {
+      
+      opt_storage[ idcs[ 0 ] ] = arg.empty() ? NULL : strdup(arg.c_str()) ;
+    };
+
+    template<>
+    inline void
+      Option< BoolAry1d >::parse(const std::string& arg, const std::vector<int>& idcs, ErrorReporter& err)
+    {      
+      xParseVec( arg, opt_storage );
+    };
+
+    template<>
+    inline void
+      Option< BoolAry2d >::parse(const std::string& arg, const IntAry1d& idcs, ErrorReporter& err)
+    {     
+      xParseVec( arg, opt_storage[ idcs[0] ] );
+    };
+
+    template<>
+    inline void
+      Option< BoolAry3d >::parse(const std::string& arg, const IntAry1d& idcs, ErrorReporter& err )
+    {     
+      xParseVec( arg, opt_storage[idcs[0]][idcs[1]] );
+    };
+#else
     template<>
     inline void
@@ -307,4 +565,5 @@
     }
 #endif
+#endif
     /** Option class for argument handling using a user provided function */
     struct OptionFunc : public OptionBase
@@ -316,5 +575,9 @@
       {}
 
+#if NH_MV_SEI
+      void parse(const std::string& arg, const std::vector<int>& idcs, ErrorReporter& error_reporter)
+#else
       void parse(const std::string& arg, ErrorReporter& error_reporter)
+#endif
       {
         func(parent, arg, error_reporter);
@@ -388,4 +651,33 @@
         operator()(const std::string& name, std::vector<T>& storage, T default_val, unsigned uiMaxNum, const std::string& desc = "" )
       {
+#if NH_MV_SEI
+        std::vector<T> defVal;
+        defVal.resize( uiMaxNum, default_val ); 
+        std::vector< int > maxSize; 
+        maxSize.push_back( uiMaxNum ); 
+        parent.addOption(new Option< std::vector<T> >( name, storage, defVal, desc, false, maxSize ));
+
+        return *this;
+      }
+
+      template<typename T>
+      OptionSpecific&
+        operator()(const std::string& name, std::vector< std::vector<T> >& storage, T default_val, unsigned uiMaxNumDim1, unsigned uiMaxNumDim2, const std::string& desc = "" )
+      {
+        std::vector< std::vector<T> > defVal;
+        defVal.resize(uiMaxNumDim1);
+        for ( unsigned int idxDim1 = 0; idxDim1 < uiMaxNumDim1; idxDim1++ )
+        {
+          defVal[ idxDim1 ].resize(uiMaxNumDim2, default_val );          
+        }
+
+        std::vector< int > maxSize; 
+        maxSize.push_back( uiMaxNumDim1 ); 
+        maxSize.push_back( uiMaxNumDim2 ); 
+
+        parent.addOption(new Option< std::vector< std::vector<T> > >( name, storage, defVal, desc, false, maxSize ));
+        return *this;
+      }
+#else
         std::string cNameBuffer;
         std::string cDescBuffer;
@@ -415,4 +707,5 @@
         return *this;
       }
+#endif
 #endif
       /**
Index: /trunk/source/Lib/TLibCommon/CommonDef.h
===================================================================
--- /trunk/source/Lib/TLibCommon/CommonDef.h	(revision 1355)
+++ /trunk/source/Lib/TLibCommon/CommonDef.h	(revision 1356)
@@ -173,4 +173,7 @@
 #if NH_MV
 static const Int MAX_NUM_LAYER_IDS =                               63;
+#if NH_MV_SEI
+static const Int MAX_NUM_SEIS      =                               1000;
+#endif
 #else
 static const Int MAX_NUM_LAYER_IDS =                               64;
@@ -280,4 +283,10 @@
 static const Int  MAX_NUM_PICS_RPS          =                     16 ; 
 static const Int  MAX_NUM_REF_LAYERS        =                     63 ;  
+#if NH_MV_SEI
+static IntAry1d getRangeVec( Int rngStart, Int rngEnd ) { IntAry1d rng; for (Int i = rngStart; i<=rngEnd; i++) rng.push_back(i);  return rng; };
+static const IntAry1d IDR_NAL_UNIT_TYPES   = getRangeVec( NAL_UNIT_CODED_SLICE_IDR_W_RADL, NAL_UNIT_CODED_SLICE_IDR_N_LP ); 
+static const IntAry1d IRAP_NAL_UNIT_TYPES  = getRangeVec( NAL_UNIT_CODED_SLICE_BLA_W_LP  , NAL_UNIT_CODED_SLICE_CRA      ); 
+
+#endif
 #endif
 
Index: /trunk/source/Lib/TLibCommon/SEI.cpp
===================================================================
--- /trunk/source/Lib/TLibCommon/SEI.cpp	(revision 1355)
+++ /trunk/source/Lib/TLibCommon/SEI.cpp	(revision 1356)
@@ -32,5 +32,5 @@
  */
 
-/** \file     SEI.cpp
+/** \file     #SEI.cpp
     \brief    helper functions for SEI handling
 */
@@ -38,4 +38,7 @@
 #include "CommonDef.h"
 #include "SEI.h"
+#if NH_MV_SEI
+#include "TComSlice.h"
+#endif
 
 SEIMessages getSeisByType(SEIMessages &seiList, SEI::PayloadType seiType)
